using UnityEngine;
using UnityEngine.UI;
using TMPro;
using BackEnd;

public class FindPW : LoginBase
{
	[SerializeField]
	private	Image				imageID;			// ID ʵ  
	[SerializeField]
	private	TMP_InputField		inputFieldID;		// ID ʵ ؽƮ  
	[SerializeField]
	private	Image				imageEmail;			// E-mail ʵ  
	[SerializeField]
	private	TMP_InputField		inputFieldEmail;	// E-mail ʵ ؽƮ  

	[SerializeField]
	private	Button				btnFindPW;			// "йȣ ã" ư (ȣۿ /Ұ)

	public void OnClickFindPW()
	{
		// Ű Է InputField UI  Message  ʱȭ
		ResetUI(imageID, imageEmail);

		// ʵ  ִ üũ
		if ( IsFieldDataEmpty(imageID, inputFieldID.text, "̵") )			return;
		if ( IsFieldDataEmpty(imageEmail, inputFieldEmail.text, " ּ") )	return;

		//   ˻
		if ( !inputFieldEmail.text.Contains("@") )
		{
			GuideForIncorrectlyEnteredData(imageEmail, "  ߸Ǿϴ.(ex. address@xx.xx)");
			return;
		}

		// "йȣ ã" ư ȣۿ Ȱȭ
		btnFindPW.interactable = false;
		SetMessage(" ߼Դϴ.");

		// ڳ  йȣ ã õ
		FindCustomPW();
	}

	/// <summary>
	/// йȣ ϱ  ̸ ߼ õ  κ ޹ message   ó
	/// </summary>
	private void FindCustomPW()
	{
		// µ йȣ  ̸Ϸ ߼
		Backend.BMember.ResetPassword(inputFieldID.text, inputFieldEmail.text, callback =>
		{
			// "йȣ ã" ư ȣۿ Ȱȭ
			btnFindPW.interactable = true;

			//  ߼ 
			if ( callback.IsSuccess() )
			{
				SetMessage($"{inputFieldEmail.text} ּҷ  ߼Ͽϴ.");
			}
			//  ߼ 
			else
			{
				string message = string.Empty;

				switch ( int.Parse(callback.GetStatusCode()) )
				{
					case 404:	// ش ̸ ̸Ӱ  
						message = "ش ̸ ϴ ڰ ϴ.";
						break;
					case 429:	// 24ð ̳ 5ȸ ̻  ̸  ̵/йȣ ã⸦ õ 
						message = "24ð ̳ 5ȸ ̻ ̵/йȣ ã⸦ õ߽ϴ.";
						break;
					default:
						// statusCode : 400 => Ʈ  Ưڰ ߰  (ȳ  ̹߼   ߻)
						message = callback.GetMessage();
						break;
				}

				if ( message.Contains("̸") )
				{
					GuideForIncorrectlyEnteredData(imageEmail, message);
				}
				else
				{
					SetMessage(message);
				}
			}
		});
	}
}

